%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Summary: iSCSI daemon and utility programs
Name: iscsi-initiator-utils
Version: 6.2.0.871
Release: 0.20%{?dist}
Source0: http://people.redhat.com/mchristi/iscsi/rhel5.5.z/source/open-iscsi-2.0-871.1-bnx2i.0.5.15.tar.gz
Source1: iscsid.init
Source2: iscsidevs.init
Patch0: iscsi-initiator-utils-update-initscripts-and-docs.patch
Patch1: iscsi-initiator-utils-use-var-for-config.patch
Patch2: iscsi-initiator-utils-add-info-compat.patch
Patch3: iscsi-initiator-utils-use-red-hat-for-name.patch
Patch4: iscsi-initiator-utils-add-libiscsi.patch
Patch5: iscsi-initiator-utils-build-fw-as-lib.patch
Patch6: iscsi-initiator-utils-uip-mgmt.patch
Patch7: iscsi-initiator-utils-iscsid-context-segf-disable-wq-p.patch
Patch8: iscsi-initiator-utils-dont-set-host-ip-for-be2iscsi.patch
Patch9: iscsi-initiator-utils-add-disc-rec-support.patch
Patch10: iscsi-initiator-utils-fix-brcm-nic-state.patch
Patch11: iscsi-initiator-utils-fix-uip-init-race.patch
Patch12: iscsi-initiator-utils-fix-semop-log.patch

Group: System Environment/Daemons
License: GPL
URL: http://www.open-iscsi.org
Buildroot: %{_tmppath}/%{name}-root
BuildRequires: openssl-devel flex bison python-devel doxygen
Prereq: /sbin/chkconfig
ExcludeArch: s390 s390x

%description
The iscsi package provides the server daemon for the iSCSI protocol,
as well as the utility programs used to manage it. iSCSI is a protocol
for distributed disk access using SCSI commands sent over Internet
Protocol networks.

%prep
%setup -q -n open-iscsi-2.0-871.1-bnx2i.0.5.15
%patch0 -p1 -b .update-initscripts-and-docs
%patch1 -p1 -b .use-var-for-config
%patch2 -p1 -b .add-info-compat
%patch3 -p1 -b .use-red-hat-for-name
%patch4 -p1 -b .add-libiscsi
%patch5 -p1 -b .build-fw-as-lib
%patch6 -p1 -b .uip-mgmt
%patch7 -p1 -b .iscsid-context-segf-disable-wq-p
%patch8 -p1 -b .dont-set-host-ip-for-be2iscsi
%patch9 -p1 -b .add-disc-rec-support
%patch10 -p1 -b .fix-brcm-nic-state
%patch11 -p1 -b .fix-uip-init-race
%patch12 -p1 -b .fix-semop-log

%build
make OPTFLAGS="%{optflags}" -C utils/sysdeps
make OPTFLAGS="%{optflags}" -C utils/fwparam_ibft
make OPTFLAGS="%{optflags}" -C usr
make OPTFLAGS="%{optflags}" -C utils
make OPTFLAGS="%{optflags}" -C libiscsi

cd brcm_iscsi_uio
./configure
make OPTFLAGS="%{optflags}"
cd ..

pushd libiscsi
python setup.py build
popd

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man8
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/iscsi
mkdir -p $RPM_BUILD_ROOT/var/lib/iscsi
mkdir -p $RPM_BUILD_ROOT/var/lib/iscsi/nodes
mkdir -p $RPM_BUILD_ROOT/var/lib/iscsi/send_targets
mkdir -p $RPM_BUILD_ROOT/var/lib/iscsi/static
mkdir -p $RPM_BUILD_ROOT/var/lib/iscsi/isns
mkdir -p $RPM_BUILD_ROOT/var/lib/iscsi/slp
mkdir -p $RPM_BUILD_ROOT/var/lib/iscsi/ifaces
mkdir -p $RPM_BUILD_ROOT/var/lock/iscsi
mkdir -p $RPM_BUILD_ROOT%{_libdir}
mkdir -p $RPM_BUILD_ROOT%{_includedir}
mkdir -p $RPM_BUILD_ROOT%{python_sitearch}

install -m 755 usr/iscsid usr/iscsiadm utils/iscsi-iname usr/iscsistart $RPM_BUILD_ROOT/sbin
install -m 644 doc/iscsiadm.8 $RPM_BUILD_ROOT/%{_mandir}/man8
install -m 644 doc/iscsid.8 $RPM_BUILD_ROOT/%{_mandir}/man8
#install -m 755 etc/initd/initd.redhat $RPM_BUILD_ROOT/etc/rc.d/init.d/iscsi
install -m 644 etc/iscsid.conf $RPM_BUILD_ROOT/etc/iscsi

install -m 755 %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/iscsid
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/iscsi

install -m 755 utils/fwparam_ibft/libfwparam.a $RPM_BUILD_ROOT%{_libdir}
install -m 444 include/fw_context.h  $RPM_BUILD_ROOT%{_includedir}
install -m 444 usr/iscsi_list.h  $RPM_BUILD_ROOT%{_includedir}

install -p -m 755 libiscsi/libiscsi.so.0 $RPM_BUILD_ROOT%{_libdir}
ln -s libiscsi.so.0 $RPM_BUILD_ROOT%{_libdir}/libiscsi.so
install -p -m 644 libiscsi/libiscsi.h $RPM_BUILD_ROOT%{_includedir}

install -m 755 brcm_iscsi_uio/src/unix/brcm_iscsiuio $RPM_BUILD_ROOT/sbin

install -p -m 755 libiscsi/build/lib.linux-*/libiscsimodule.so \
	$RPM_BUILD_ROOT%{python_sitearch}


%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

if [ ! -f /etc/iscsi/initiatorname.iscsi ]; then
	echo "InitiatorName=`/sbin/iscsi-iname`" > /etc/iscsi/initiatorname.iscsi
chkconfig --level 06 network off 
rm /etc/rc0.d/*network 
rm /etc/rc6.d/*network 

fi
/sbin/chkconfig --add iscsid
/sbin/chkconfig --add iscsi

%postun
/sbin/ldconfig


%preun
if [ "$1" = "0" ]; then
    /sbin/chkconfig --del iscsi
    /sbin/chkconfig --del iscsid
fi

%files
%defattr(-,root,root)
%doc README
%dir /var/lib/iscsi/nodes
%dir /var/lib/iscsi/send_targets
%dir /var/lib/iscsi/static
%dir /var/lib/iscsi/slp
%dir /var/lib/iscsi/isns
%dir /var/lib/iscsi/ifaces
%dir /var/lib/iscsi
%dir /var/lock/iscsi
%dir /etc/iscsi
%config /etc/rc.d/init.d/iscsi
%config /etc/rc.d/init.d/iscsid
%attr(0600,root,root) %config(noreplace) /etc/iscsi/iscsid.conf
/sbin/*
%{_mandir}/*/*
%{_libdir}/libiscsi.so.0
%{python_sitearch}/libiscsimodule.so
%{_libdir}/libfwparam.a
%{_includedir}/fw_context.h
%{_includedir}/iscsi_list.h

#files devel
%defattr(-,root,root,-)
%doc libiscsi/html
%{_libdir}/libiscsi.so
%{_includedir}/libiscsi.h

%changelog
* Fri Sep 3 2010 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.20
- Change upstream pointer to fix build issue.

* Tue Aug 31 2010 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.19
- 624344 Fix semarg use in logging code.

* Wed Jul 7 2010 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.18
- 572596, 595549 Fix uIP iscsid synchronization
- 580743 Fix brcm_iscsiuio segfault 

* Wed Jun 16 2010 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.17
- 592736 Add discovery mode record support.

* Tue Mar 9 2010 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.16
- 570893 Fix bnx2x uip panic due to the packet index in the VLAN field of the
BD does not match the packet index expected by the firmware when the index crosses a BD page.

* Mon Jan 25 2010 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.15
- 556984 Load be2iscsi driver when init script is run

* Wed Dec 23 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.14
- 511271 Do not run chkconfig on net scripts on startup (Did not commit
the right file last time).

* Mon Dec 21 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.13
- 517380 Update Broadcom iSCSI userspace components.
- 504666 When using iscsi ifaces with different initiator names only the default name is used for discovery.
- 514926 iSCSI does not reconnect after ifdown and ifup.
- 511271 Do not run chkconfig on net scripts on startup.
- 531748 Fix typo in iscsiadm session print out where REOPEN was mispelled
as REPOEN.

* Sun Dec 20 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.12
- 514926 Another fix for the ifdown reconnection handling

* Tue Sep 29 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.11
- 514926 Sync brcm uio to 0.4.8 to fix ifdown reconnection handling
- 520508 Fix login/connect timeout due to MAC addr mishandling.

* Tue Aug 11 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.10
- 515806 Do not try to bind by ip address when syncing iscsid

* Mon Jul 27 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.9
- 513726 Sync brcm uio to 0.4.3 to fix ISCSI_KEVENT_IF_DOWN handling segfault.

* Thu Jul 19 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.8
- 508782 fix iscsid/iscsistart segfault due to bad conn context cast
- Fix bnx2i login when iface uses only the hwaddress.

* Tue Jun 16 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.7
- 505958 load bnx2i and cxgb3i drivers
- 481807 Fix ownership of /etc/iscsi dir
- Fix leak in iscsid when setting iscsi wq thread nice/priority.
- 442418 Add Broadcom bnx2i userspace support.

* Tue May 20 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.4
- 458203 Bring in changes for offload like cxgb3i

* Tue May 12 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.3
- 499565 Remove static libiscsi and add and fixup libfwparam

* Tue May 12 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.3
- 499565 Install libiscsi as static for anaconda

* Tue May 12 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.2
- 249049 create debug rpms by removing -s from the install command
- 499565 Install libfwparam.a and headers for anaconda

* Sun May 10 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.1
- 499565 Add fwparm for anaconda

* Fri May 1 2009 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.0
- 458203 Rebase to upstream 870-test2 to bring in ppc and other boot fixes

* Wed Dec 17 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.871-0.0
- 458203 Rebase to upstream, and add usr libiscsi.

* Wed Dec 17 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.18
- 476752 Must install list.h (install as iscsi_list.h) because fw_context.h
is bringing it in. Also revert ibft name changes because anaconda is using
them instead of the fw_context.h functions.

* Tue Dec 2 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.17
- 472562 (additional fixup to patch) only use logout time2wait for
relogins when response code is 2 or 3.

* Sun Nov 30 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.16
- 432819 create node records for each ibft portal and log into all of them

* Wed Nov 22 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.15
- 472562 always retry relogins.

* Wed Nov 19 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.14
- 432819 increase CHAP string sizes.

* Wed Nov 5 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.12
- 469162 /var/lib/iscsi was not listed as owned by this package.

* Thu Sep 18 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.11
- 253834 fix iscsid init script shutdown

* Thu Sep 16 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.10
- 461294 Port login retry fixes from upstream.

* Wed Aug 26 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.9
- Related to 445721 - Install fw helpers as lib so first stage of
installer can easily use it. This is a temp lib, and is not a stable
interface. For now, just for install, we are adding this library.

* Wed Aug 6 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.8
- Related to 445721 - when using intel nics some network values are
not set, so iscsiadm would fail instead of just printing what we got.

* Mon Apr 28 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.7
- 444379 Increase login retries for boot.

* Mon Mar 25 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.6
- 438092 Print netdev.

* Mon Mar 25 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.5
- 438092 Print ibft net info (waiting on ppc support from IBM).
- 437195 Use CHAP values from sysfs during resync, incase they were from ibft.
- 437195 Update README to reflect that users should set node.startup

* Mon Mar 3 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.4
- 433514 Handle ipv6 compat and mapped addrs in isns client

* Wed Jan 23 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.3
- 307741 Fix reading of ibft sysfs values.
- 307741 Pick up tpgt dynamically.

* Thu Jan 17 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.2
- 307741 Add fw mode login command.

* Thu Jan 3 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.1
- 307741 From Konrad Rzeszutek - read ibft info from sysfs.

* Thu Jan 3 2008 Mike Christie <mchristie@redhat.com> - 6.2.0.868-0.0
- 307741 Initial support for ibft.

* Mon Aug 27 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.865-0.8
- 255641 Fix login redirect handling.
- Try all matching portals during startup.

* Tue Aug 21 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.865-0.7
- 250140 Document how to set timers when using multipath or iscsi root.
- 249053 Document iscsid and iscsiadm debug argument.

* Thu Jun 28 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.865-0.6
- 246146 fix ipv6 README and document that we do not support isns.

* Mon Jun 25 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.865-0.5
- Fix regression from 227554. Fix iscsiadm -m logoutall command.

* Wed Jun 20 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.865-0.4
- 244987 Forgot to upload correct patch for db root dir.

* Wed Jun 20 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.865-0.3
- 222789 update date in initiatorname

* Wed Jun 20 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.865-0.2
- 244987 old tools used to make the root db dir for apps and anaconda relied
on that. This is a regression from 227554.

* Tue Jun 19 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.865-0.1
- Bring in fixes that got merged in git but did not make the 865 release and
code that partners need to test due to lack of hw limitations.

* Tue Jun 12 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.865-0.0
- Rebase to upstream to bring in bug and security fixes.
- 243727 CVE-2007-3099 CVE-2007-3100
- 227554 Support only passing in a target with iscsiadm commands.
- 227698 ipv6 fixups

* Sat Feb 10 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.742-0.6
-  Patch for 218841 was not getting applied because 'BZ' in the patch
caused rpm to try and bunzip it instead of apply it.
- 227815 update docs to make it more clear what is node mode. 

* Wed Jan 19 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.742-0.5
- BZ 218791 - We get a network hang when the firewall is started
- and to allow iscsi root boot to work we start iscsid early.
- This breaks up iscsi.init into iscsidevs.init (start iscsi targets)
- and iscsid.init (start iscsi daemon). Users should be using
- iscsiadm for management instead of the rc script, but we add some compat
- code to make it a little easier.

* Wed Jan 17 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.742-0.4
- BZ 223051 - targets not logged into automatically according to docs

* Tue Jan 9 2007 Mike Christie <mchristie@redhat.com> - 6.2.0.742-0.3
- BZ 221088 - add support for sysfs paths for sid in session mode

* Mon Dec 11 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.742-0.2
- BZ 218841. Handle errors in netlink message handling.

* Mon Nov 28 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.742-0.1
- BZ 216715 again. Fix regression from documenting the iscsid.conf file (setto better match RHEL4).

* Sat Nov 25 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.742-0.0
- BZ 217246 - Don't flood targets with nop-outs.

* Fri Nov 24 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.737-0.0
- BZ 216715 - add missing functionality from RHEL3/4.
- Fixup docs for Red Hat specifics.

* Mon Nov 7 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.730-0.0
- BZ 212263 - load iser
- Rebase to upstream open-iscsi-2.0-730 to bring in fixes we were
- managing but are now upstream and bring in fixes I had done upstream
- for other partner/distro testing.

* Tue Oct 17 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.695-0.8
- Change period to colon in default name

* Fri Oct 13 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.695-0.7
- BZ 210470 update man pages for file moves
- Fix targetname strcmp
- read default config before doing discovery

* Thu Oct 5 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.695-0.6
- BZ 209523 make sure the network is not going to get shutdown so
iscsi devices (include iscsi root and dm/md over iscsi) get syncd.
- BZ 209415 have package create iscsi var dirs

* Tue Oct 3 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.695-0.5
- BZ 208864 move /etc/iscsi/nodes and send_targets to /var/lib/iscsi

* Mon Oct 1 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.695-0.4
- BZ 208548 move /etc/iscsi/lock to /var/lock/iscsi/lock

* Wed Sep 27 2006 Jeremy Katz <katzj@redhat.com> - 6.2.0.695-0.3
- Add fix for initscript with pid file moved

* Tue Sep 26 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.695-0.2
- BZ 208050 - change default initiator name to reflect redhat
- Move pid from /etc/iscsi to /var/run/iscsid.pid

* Fri Sep 15 2006 Mike Christie <mchristie@redhat.com> - 6.2.0.695-0.1
- Add compat with FC kernel so iscsid will pass startup checks and run.
- Fix bug when using hw iscsi and software iscsi and iscsid is restarted.
- Fix session matching bug when hw and software iscsi is both running

* Tue Sep  5 2006 Jeremy Katz <katzj@redhat.com> - 6.1.1.685-0.1
- Fix service startup
- Fix another case where cflags weren't being used

* Mon Aug 28 2006 Mike Christie <mchristie@redhat.com> - 6.1.1.685
- Rebase to upstream to bring in many bug fixes and rm db.
- iscsi uses /etc/iscsi instead of just etc now

* Fri Jul 21 2006 Jeremy Katz <katzj@redhat.com> - 6.1.1.645-1
- fix shutdown with root on iscsi

* Thu Jul 13 2006 Mike Christie <mchristie@redhat.com> - 6.1.1.645
- update to upstream 1.1.645
- Note DB and interface changed so you must update kernel, tools and DB

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 6.0.5.595-2.1.1
- rebuild

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 6.0.5.595-2.1
- rebuild

* Wed Jun 21 2006 Mike Christie <mchristi@redhat.com> - 6.0.5.595-2
- add PatM's statics.c file. This is needed for boot since 
  there is no getpwuid static available at that time.
* Tue Jun 20 2006 Jeremy Katz <katzj@redhat.com> - 6.0.5.595-1
- ensure that we respect %%{optflags}
- cleaned up initscript to make use of standard functions, return right 
  values and start by default
- build iscsistart as a static binary for use in initrds

* Tue May 30 2006 Mike Christie <mchristi@redhat.com>
- rebase package to svn rev 595 to fix several bugs
  NOTE!!!!!!!! This is not compatible with the older open-iscsi modules
  and tools. You must upgrade.

* Thu May 18 2006 Mike Christie <mchristi@redhat.com>
- update package to open-iscsi svn rev 571
  NOTE!!!!!!!! This is not compatible with the older open-iscsi modules
  and tools. You must upgrade.

* Fri Apr 7 2006 Mike Christie <mchristi@redhat.com>
- From Andy Henson <andy@zexia.co.uk>:
  Autogenerate /etc/initiatorname.iscsi during install if not already present
- Remove code to autogenerate /etc/initiatorname.iscsi from initscript
- From dan.y.roche@gmail.com:
  add touch and rm lock code
- update README
- update default iscsid.conf. "cnx" was not supported. The correct
  id was "conn".

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 5.0.5.476-0.1
- bump again for double-long bug on ppc(64)

* Mon Jan 23 2006 Mike Christie <mchristi@redhat.com>
- rebase package to bring in ppc64 unsigned long vs unsigned
  long long fix and iscsadm return value fix. Also drop rdma patch
  becuase it is now upstream.
* Wed Dec 14 2005 Mike Christie <mchristi@redhat.com>
- initial packaging

